"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _utils = require("../utils");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _ResponsiveContext = _interopRequireDefault(require("../ResponsiveContext"));

var _useDebugResponsive = _interopRequireDefault(require("./useDebugResponsive"));

var _useMediaType2 = _interopRequireDefault(require("./useMediaType"));

var _useOrientation = _interopRequireDefault(require("./useOrientation"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ResponsiveProvider = function ResponsiveProvider(_ref) {
  var initialMediaType = _ref.initialMediaType,
      defaultOrientation = _ref.defaultOrientation,
      children = _ref.children,
      breakpoints = _ref.breakpoints,
      breakpointsMax = _ref.breakpointsMax,
      mediaQueries = _ref.mediaQueries,
      mobileBreakpoint = _ref.mobileBreakpoint;

  var breakpointsWithInitialValue = _objectSpread({
    _initial: '0em'
  }, breakpoints);

  var breakpointNames = Object.keys(mediaQueries || breakpointsWithInitialValue);

  if (!mediaQueries) {
    mediaQueries = (0, _utils.getMediaqueries)(breakpointsWithInitialValue, breakpointsMax, breakpointNames);
  }

  var breakpointsRef = (0, _react.useRef)((0, _utils.getBreakpoints)(mediaQueries, breakpointNames));

  var _useMediaType = (0, _useMediaType2["default"])(breakpointsRef, initialMediaType),
      currentMediaType = _useMediaType.currentMediaType,
      isCalculated = _useMediaType.isCalculated;

  var queriesObjects = (0, _react.useMemo)(function () {
    return (0, _utils.getQueriesObjects)(currentMediaType, breakpointsRef.current);
  }, [currentMediaType, breakpointsRef]);
  var currentOrientation = (0, _useOrientation["default"])(defaultOrientation);
  var contextObject = (0, _react.useMemo)(function () {
    return _objectSpread({
      mediaType: currentMediaType,
      orientation: currentOrientation,
      isCalculated: isCalculated,
      mobileBreakpoint: mobileBreakpoint
    }, queriesObjects);
  }, [currentMediaType, currentOrientation, isCalculated, mobileBreakpoint, queriesObjects]);
  (0, _useDebugResponsive["default"])(contextObject, currentMediaType);
  return /*#__PURE__*/_react["default"].createElement(_ResponsiveContext["default"].Provider, {
    value: contextObject
  }, children);
};

var breakpointsPropTypes = {
  xs: _propTypes["default"].string,
  sm: _propTypes["default"].string,
  md: _propTypes["default"].string,
  lg: _propTypes["default"].string,
  xl: _propTypes["default"].string
};
ResponsiveProvider.defaultProps = {
  initialMediaType: 'xs',
  defaultOrientation: null,
  mobileBreakpoint: 'md'
};
ResponsiveProvider.propTypes = {
  initialMediaType: _propTypes["default"].oneOf(['_initial', 'xs', 'sm', 'md', 'lg', 'xl']),
  defaultOrientation: _propTypes["default"].oneOf(['landscape', 'portrait']),
  children: _propTypes["default"].oneOfType([_propTypes["default"].arrayOf(_propTypes["default"].node), _propTypes["default"].node]).isRequired,
  breakpoints: _propTypes["default"].exact(breakpointsPropTypes),
  breakpointsMax: _propTypes["default"].exact(breakpointsPropTypes),
  mediaQueries: _propTypes["default"].exact(_objectSpread(_objectSpread({}, breakpointsPropTypes), {}, {
    _initial: _propTypes["default"].string
  })),
  mobileBreakpoint: _propTypes["default"].oneOf(['xs', 'sm', 'md', 'lg', 'xl'])
};
var _default = ResponsiveProvider;
exports["default"] = _default;
module.exports = exports.default;